#!/usr/bin/perl -w

# perl GenBankParser_rRNA.pl

use strict;
use warnings;

##############
my $keyWord = "16S";
##############


my $inFile     = "sequence.gb";
my $outDNAfile = "outFile.fas";


my $accNum  = "";
my $SpName  = "";
my $ordName = "";
my $famName = "";

my $dnaSeq = "";
my %productRec = ( );

my $flagSeq      = 0;
my $flagFeatures = 0;

my $address  = "";
my $address1 = "";
my $product  = "";
my $product1 = "";

###

open(INFILE,"$inFile");
open(DNASEQ,">$outDNAfile");
while(my $line = <INFILE>){
  chomp($line);


  ###### Print out when $line is " // "
  if($line =~ /^\/\//){
    print DNASEQ ">$ordName\_$famName\_$SpName\_$accNum\n";
    
    my $selectedSeq = "";
    if(my @eleTMP = grep/$keyWord/,keys %productRec){
      my $ele = shift(@eleTMP);
      #print DNASEQ "$ele\n";
      my $posTEMP = $productRec{$ele};
      my($start, $last) = split(/\.\./,$posTEMP);
      $selectedSeq = substr($dnaSeq, $start-1, $last-$start+1)
    }else{
      $selectedSeq = $keyWord."NONE";
    }
    print DNASEQ "$selectedSeq\n";

    $dnaSeq       = "";
    %productRec   = ();
    $flagSeq      = 0;
    $flagFeatures = 0;

  }
  ###### Print out END


  #### Collection for name line
  if($line =~ /^ACCESSION   /){
    $accNum = $line;
    $accNum =~ s/ACCESSION   //g;
  }
 
  if($line =~ /^  ORGANISM/){
    $line =~ s/  ORGANISM  //g;
    $line =~ s/ .*//g;
    $SpName = $line;
  }
 
  if($line =~ /[^ ]+formes;/){
    $ordName = $line;    
    $ordName =~ s/^.* ([^ ]+formes);.*/$1/;
  }

  if($line =~ /[^ ]+dae;/){
    $famName = $line;
    $famName =~ s/^.* ([^ ]+dae);.*/$1/;
  }
  #### Collection for name line  END


  ### Collection for feature lines
  if ($line =~ / +\d+\.\.\d+/){
    if($flagFeatures == 0){
      $line =~ s/^[^\d]+//;
      $address = $line;
      $flagFeatures = 1;
    }else{
      $productRec{$product} = $address;
      $product = "";
      $line =~ s/^[^\d]+//;
      $address = $line;
    }
  }
  if ($line =~ /^ +\// ){
    $line =~ s/ +//g;
    $line = $line." ";
    $product .= $line;
  }
  ### Collection for feature lines END
  


  if($flagSeq == 1){
    $line =~ s/[^a-zA-Z]//g;
    $dnaSeq .= $line;
  }
  if ($line =~ /^ORIGIN/){
    $productRec{$product} = $address;
    $flagSeq = 1;
  }


}
close DNASEQ;
close INFILE;


exit;